summaryrefslogtreecommitdiff
path: root/t/t5560-http-backend-noserver.sh
diff options
context:
space:
mode:
Diffstat (limited to 't/t5560-http-backend-noserver.sh')
-rwxr-xr-xt/t5560-http-backend-noserver.sh28
1 files changed, 22 insertions, 6 deletions
diff --git a/t/t5560-http-backend-noserver.sh b/t/t5560-http-backend-noserver.sh
index a9ba2d9aae..5f8c88e261 100755
--- a/t/t5560-http-backend-noserver.sh
+++ b/t/t5560-http-backend-noserver.sh
@@ -6,18 +6,34 @@ test_description='test git-http-backend-noserver'
HTTPD_DOCUMENT_ROOT_PATH="$TRASH_DIRECTORY"
run_backend() {
- REQUEST_METHOD=GET \
+ echo "$2" |
+ QUERY_STRING="${1#*\?}" \
GIT_PROJECT_ROOT="$HTTPD_DOCUMENT_ROOT_PATH" \
- PATH_INFO="$1" \
+ PATH_INFO="${1%%\?*}" \
git http-backend >act.out 2>act.err
}
GET() {
- return 0
+ REQUEST_METHOD="GET" \
+ run_backend "/repo.git/$1" &&
+ if ! grep "Status" act.out >act
+ then
+ printf "Status: 200 OK\r\n" >act
+ fi
+ printf "Status: $2\r\n" >exp &&
+ test_cmp exp act
}
POST() {
- return 0
+ REQUEST_METHOD="POST" \
+ CONTENT_TYPE="application/x-$1-request" \
+ run_backend "/repo.git/$1" "$2" &&
+ if ! grep "Status" act.out >act
+ then
+ printf "Status: 200 OK\r\n" >act
+ fi
+ printf "Status: $3\r\n" >exp &&
+ test_cmp exp act
}
log_div() {
@@ -28,9 +44,9 @@ log_div() {
expect_aliased() {
if test $1 = 0; then
- run_backend "$2"
+ REQUEST_METHOD=GET run_backend "$2"
else
- run_backend "$2" &&
+ REQUEST_METHOD=GET run_backend "$2" &&
echo "fatal: '$2': aliased" >exp.err &&
test_cmp exp.err act.err
fi